### TechNote

Number:06201-04
Date:November 1994

## SMARTLSP parameters

The Madge Smart LAN Support Software provides network protocol functions for Madge Smart Ringnodes. This document describes the command-line parameters for one of the programs in the Madge Smart LAN Support Software, SMARTLSP. It refers to SMARTLSP version 3.31.

When you load SMARTLSP.EXE, it displays a message that includes the version number and shows which of the available interfaces (Interrupt arbitrator, LLC, and Netbios) is enabled as described below. If there is an error at load time, the system displays an error message. You can run SMARTLSP.EXE from AUTOEXEC.BAT. However, we recommend that you run SMARTLSP.EXE from CONFIG.SYS if possible.

SMARTLSP supports many additional command-line parameters to control aspects of its operation. The default parameter values suit most circumstances. You seldom need to change them. The most likely situation in which you may want to alter them is when you run a server that supports a large number of workstations. The complete syntax of the SMARTLSP command line is:

`SMARTLSP.EXE [NOLLC] [NONETB] [PC3270] [<adapter 0 parameters>] [ ,<adapter 1 parameters>]`

where <adapter 0 parameters> and <adapter 1 parameters> represent sets of parameters that you may specify separately for each of two Ringnodes. Use a comma to separate the parameters for adapter 0 from those for adapter 1. Each set of parameters has the following syntax:

[<node>] [<parameters>]

Optional items are shown here enclosed in square brackets. Do not include the brackets when you type an optional item in a command line. The options are listed after the following example of a SMARTLSP command line:

`SMARTLSP LLC IO=3A20 40001111222 SA=5 SR=Y, IO=1A20 40001111333 SO=40 SR=Y`

The following are options for the SMARTLSP command line:

NOLLC
  This option indicates that you do not require an LLC 802.2 interface. This parameter can be given if the only applications you are using are Netbios applications such as PC LAN. It saves a significant amount of PC memory space, typically reducing the memory consumption from 11 Kbytes to 3 Kbytes. Note that this parameter only disables the external interface to the LLC. It does not disable the operation of the LLC protocols because these are required for the Netbios to work.

  When you use this option, the interrupt arbitrator interface is also disabled.

NONETB
  This indicates that you do not require a Netbios interface. This parameter can be given if the only applications you are using are LLC applications such as Novell NetWare or a 3270 attachment program. This option disables the Netbios functions of SMARTLSP. Therefore, if you want to, it is possible to run a separate Netbios program (such as the IBM LAN Support Netbios or the Madge MNETBIOS program) on top of the LLC interface. It does not reduce PC memory usage but it does enable the LLC to use more of the Ringnode's memory, thus allowing support for more SAPs and link stations. Using this option typically increases the number of links that can be supported from 90 to 180.

  Note

  Do not include both the NOLLC and NONETB options in the same SMARTLSP command.

LOMEM
  You require this option when using Smart Ringnodes running in DMA mode with certain software or hardware, which remaps memory. Examples of software that require this option are:

  - Microsoft Windows 386
  - Virtual 386 mode applications
  - Extended and expanded memory managers
  For further information, refer to the "Using the SMARLSP driver" information file in the INFO utility.

PC3270
  You need this option when you are using the IBM Personal Communications 3270 program version 1.00. Do not use this option with any other version of the IBM Personal Communications 3270 program.

<node>
  Use this to specify the node address that the Ringnode will use. It must be a hexadecimal number in the range 400000000000 to 7FFFFFFFFFFF. If you do not include this option, the Ringnode uses its burnt-in unique address. Each Ringnode must have a different node address for the network to function correctly. If you want to make the number easier to read, include spaces in this parameter to divide up the digits. A sample node address is:

  `4000 1234 5678`

PIO
  This option disables bus-master DMA mode on the adapter card, and uses Programmed IO instead. This option avoids the problem of having memory managers loaded, but without the extra memory usage of LOMEM. Note that SMARTLSP detects the presence of some of these programs and enables the LOMEM or PIO option automatically.

WIN
  This option specifies that you are using Microsoft Windows 3.0 or 3.1. Specify the version you are using as '30' or '31'. For example, WIN=31.

  You can specify a number of [additional parameters for each adapter. The format of a parameter is:

  `<parameter>=<value>`

  You can specify each parameter in either an abbreviated form or, to improve readability, a long form. For example, to specify five SAPs, the parameter is either:

  `SA=5` (abbreviated form)
  or:
  `SAPS=5` (long form)

  Most of the parameters are the same as those supported by the IBM LAN Support Program.

  Most of the parameters control the Netbios interface and therefore, have no effect if you specify the NONETB option. However, SAPS (SA), STATIONS (ST), and EXTRA.STATIONS (EST) are LLC parameters and as such are always used.

  The valid parameters are:

      ANR                     range:     Y or N
      ADAP.ADDR.NOT.REVERSED  default:   N

  This controls the byte ordering of the node address that appears in the Netbios status area and in the Netbios permanent name. Normally, this node address is byte-reversed (so that, for example, the broadcast bit appears in bit 7 of the 6th byte). If you set the parameter to YES, the node address is not byte-reversed. This is not normally required.

      C                       range:     0 - 255
      COMMANDS                default:   32

  This specifies the maximum number of NCBs that the Netbios program handles at any one time. If any NCBs are issued above this number, they are rejected by the Netbios program. The default value of 32 is sufficient for most Netbios application programs. It may be necessary to increase the value of this parameter on some high-performance servers. Reducing this parameter releases some Ringnode resources for other uses and slightly increases the maximum number of link stations and sessions that are supported.

      CR                      range:     Y or N
      CLOSE.ON.RESET          default:   N

  This controls Netbios behaviour when it receives a RESET command. With the default setting of NO, Netbios closes its own SAP and then reopens it (this does not interfere with other LLC users). If you set this parameter to YES, Netbios closes the adapter and then reopens it. If there are other LLC users, this may cause problems.

      DG                      range:     Y or N
      DATAGRAM.MAX            default:   N

  This controls the maximum size of datagrams that the Netbios interface transmits. If you set this parameter to NO, the maximum size is 512 bytes. If you set this parameter to YES, the maximum size is determined from the FRAME.SIZE parameter and may be larger than 512 bytes. Broadcast datagrams are always limited to 512 bytes. We strongly recommend that all Netbios application programs are limited to 512 byte datagrams because some Netbios implementations may not support larger sizes.

      EST                     range:     0 - 254
      EXTRA.STATIONS          default:   3

  This specifies the number of LLC links that are available to applications other than Netbios. The default value of 3 allows you to use an LLC workstation application that requires one link in addition to using Netbios, without requiring any additional parameters. Note that the total of STATIONS and EXTRA.STATIONS must be less than 255.

      FS                      range:     200 - 17814
      FRAME.SIZE              default:   2048

  This specifies the maximum frame size that Netbios transmits. This frame size includes all protocol headers, so the actual amount of Netbios data in the frame is somewhat less than the value of the parameter.

  The actual default value of this parameter depends on the combination of interfaces that you enable. For detailed information, refer to the "Using the SMARTLSP driver" information file in the INFO utility.

      IO                      range:     A20...
      IO.LOCATION             default:   any

  This specifies a particular I/O location in which the Smart software looks for an adapter. If you select this option, the software only looks at the specified location for the adapter. This is useful if you have more than one adapter installed and you wish to restrict the software to a single adapter. The values you are allowed to specify for this option depend on the type of Ringnode. For more information, see "Using the SMARTLSP and SMARTIPX drivers" information file in the INFO utility.

      MI                      range:     0 - 127
      DLC.MAXIN               default:   1
      MO                      range:     0 - 127
      DLC.MAXOUT              default:   2

  These two parameters specify the maximum number of I-frames that can be received or transmitted on Netbios links without waiting for or sending an LLC level acknowledgement. The default values are suitable for most situations. In some cases, a slight performance gain may be achieved by increasing the values (for example to 2 and 4). Take care if you change the values of these parameters, because you must change the values in a consistent way on all Netbios interfaces that are to communicate with one another.

      MOI                     range:     0 -  255
      DLC.MAXOUT.INCR         default:   1

  This controls the dynamic window algorithm that you use to improve recovery from network congestion problems, (typically when you are using bridges). If you increase the value of this parameter from the default, the transmit window size increases more slowly after a temporary network congestion condition causes the loss of a frame.

      N                       range:     2 - 254
      NAMES                   default:   17

  The NAMES keyword specifies the maximum number of Netbios names that the Ringnode has at any one time. This number includes the permanent name. The default of 17 is almost always sufficient except in certain applications such as Netbios bridges.

  R

      A                      range:     0 - 3
      RING.ACCESS             default:   0

  This specifies the access priority with which all frames are transmitted on the ring. Take great care when changing this value from the default because a value greater than zero might result in other stations being unable to access the network.

      RC                      range:     1 - 255
      DLC.RETRY.COUNT         default:   15

  This specifies the number of times the LLC reattempts failed transmissions of I-frames on links that Netbios uses. The default value is appropriate for most situations.

      RX                      range:     100 - 17960
      RX.SIZE                 default:   2150

  This specifies the maximum size of LLC frame that can be received if you enable the LLC interface.

      S                       range:     0 - 254
      SESSIONS                default:   32

  This specifies the maximum number of Netbios sessions that may be open at one time. The default value is 32, which is the same as the default value for STATIONS. For most Netbios applications, set this parameter to the same value as STATIONS. However, if an application opens several Netbios sessions with the same remote network station, it may be advisable to make the SESSIONS parameter larger than the STATIONS parameter. Although the maximum allowed value is 254, the amount of available memory typically imposes a limit of about 90.

      SA                      range:     0 - 127
      SAPS                    default:   2

  This specifies the maximum number of LLC Service Access Points (SAPs) that may be open at one time. The Netbios interface always uses one SAP (unless you specify the NONETB option) and therefore, all additional SAPs are available for other LLC application programs to use. The default value of 2 allows one SAP for Netbios and one for another LLC application such as Novell NetWare or a 3270 attachment program. The EXTRA.SAPS (ES) parameter specifies the number of extra SAPs that are added to the SAPS parameter to obtain the total number of SAPs available. Make sure the total of the SAPS and EXTRA.SAPS parameters is not greater than 128.

      ST                      range:     1 - 254
      STATIONS                default:   32

  This specifies the maximum number of LLC links that the Netbios interface uses. Netbios always uses all of the stations this parameter specifies (unless you specify the NONETB option). Therefore, use the EXTRA.STATIONS parameter to specify any link stations required by other LLC application programs. Although the maximum allowed value is 254, the amount of available memory typically imposes a limit of about 90, or 180 if you specify the NONETB option. Note - the total of STATIONS and EXTRA.STATIONS must be less than 255.

      T1                      range:     0 - 10
      DLC.T1                  default:   5
      T2                      range:     0 - 11
      DLC.T2                  default:   0
      TI                      range:     0 - 10
      DLC.TI                  default:   10

  These three parameters control three LLC timers.

  DLC.T1 specifies the value of the LLC retransmission timer for Netbios links. This controls the delay between transmitting and retransmitting a frame if no acknowledgement is received. The default value of 5 gives a retry timeout of 2 seconds that is appropriate for most situations.

  DLC.T2 specifies the value of the LLC acknowledgement timer for Netbios links. This controls the delay before acknowledging a received frame when the receive window has not been reached. If you specify a value of 11, this timer is disabled and acknowledgements are never sent until the receive window is reached.

  The DLC.TI parameter specifies the value of the LLC inactivity timer for Netbios links. This timer determines the frequency with which the LLC sends poll frames on a link, which is otherwise inactive, to check that the link is still functional. The default value of 10 gives a time-out of about thirty seconds. This value is longer than that of the Netbios link inactivity timer, so that normally the Netbios timer expires first and sends a poll frame thus restarting the LLC’s timer. In some circumstances, it may be desirable to reduce the value of this LLC timer.

  All three LLC timer parameters described above (DLC.T1, DLC.T2, and DLC.TI) use timing units determined by the LLC.

      TC                      range:     1 - 10
      TRANSMIT.COUNT          default:   6
      TT                      range:     0 - 20
      TRANSMIT.TIMEOUT        default:   1

  These two parameters specify the maximum number of times Netbios protocol UI frame requests are retried, and the delay between successive retries (in units of half a second).

      TXI                     range:     2 - 255
      TX.I.BUFFERS            default:   32
      TXU                     range:     2 - 255
      TX.U.BUFFERS            default:   10

  These two parameters control Netbios' handling of its internal buffer. It is unlikely that you need to change the default values. Very rarely, if a Netbios application is making very heavy use of Netbios datagrams, increasing the value of TX.U.BUFFERS provides a slight improvement in performance.